/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.sample;

import org.junit.Ignore;

@Ignore
public class SampleProcessorTest {
//
//	/** bark frequencies */
//	private int[] barkStopFreqs;
//	SampleProcessor sp;
//
//	@org.junit.Before
//	public void setup() {
//		PropertiesConfiguration con = new PropertiesConfiguration();
//		con.setProperty(FingerprintKey.SAMPLE_RATE, 8192);
//		con.setProperty(FingerprintKey.SAMPLE_WINDOW, 8192);
//		con.setProperty(FingerprintKey.BARK_BAND_STOPS,
//				new String[] { "100", "200", "300", "400", "510", "630", "770",
//						"920", "1080", "1270", "1480", "1720", "2000", "2320",
//						"2700", "3150", "3700" });
//		con.setProperty(FingerprintKey.ZERO_SPECTRUM_TRESHOLD, 181.0193);
//		con.setProperty(FingerprintKey.BARK_BAND_STOP_COUNT, 16);
//
//		barkStopFreqs = CnfUtil.toIntArray(con
//				.getStringArray(FingerprintKey.BARK_BAND_STOPS));
//
//		sp = new SampleProcessor(con, null);
//	}
//
//	@Test
//	public void testBarkFrequencies() {
//		for (int bark = 0; bark < barkStopFreqs.length - 1; bark++) {
//			// average frequency
//			int freq = (barkStopFreqs[bark] + barkStopFreqs[bark + 1]) / 2;
//			int samplewindowinbytes = 8192 * 2;
//			double samplerate = 8192.0;
//			byte[] data = new byte[samplewindowinbytes];
//			ByteBuffer bb = ByteBuffer.wrap(data);
//			bb.order(ByteOrder.nativeOrder());
//			ShortBuffer sb = bb.asShortBuffer();
//			for (int i = 0; sb.hasRemaining(); i++) {
//				double d = Math.sin(2.0 * Math.PI * (freq / samplerate) * i);
//				sb.put((short) (Short.MAX_VALUE * d));
//			}
//			double[] barkArr = sp.rawToRawBarks(data);
//			// System.out.println(Arrays.toString(barkArr));
//			for (int i = 0; i < barkArr.length; i++) {
//				if (i == bark) {
//					Assert.assertTrue(barkArr[i] > 1);
//				} else {
//					Assert.assertTrue(barkArr[i] < 1);
//				}
//			}
//		}
//	}
//
//	@Test
//	public void testBarkFreqIndexes() {
//		int[][] barkFreqs = sp.barkFreqIndexes();
//		Assert.assertEquals(barkStopFreqs.length - 1, barkFreqs.length);
//		Assert.assertEquals(100, barkFreqs[0].length);
//		Assert.assertEquals(100, barkFreqs[0][0]);
//		Assert.assertEquals(199, barkFreqs[0][barkFreqs[0].length - 1]);
//		Assert.assertEquals(100, barkFreqs[1].length);
//		Assert.assertEquals(200, barkFreqs[1][0]);
//		Assert.assertEquals(299, barkFreqs[1][barkFreqs[1].length - 1]);
//		Assert.assertEquals(550, barkFreqs[15].length);
//		Assert.assertEquals(3150, barkFreqs[15][0]);
//		Assert.assertEquals(3699, barkFreqs[15][barkFreqs[15].length - 1]);
//	}
//
//	@Test
//	public void testEmpty() {
//		Assert.assertArrayEquals(new double[16], sp
//				.rawToRawBarks(new byte[8192 * 2]), 0.0);
//	}
//
//	@Test
//	public void testFrequenciesAsc() {
//		int freq = 220;
//		int samplewindowinbytes = 8192 * 2;
//		double samplerate = 8192.0;
//		byte[] data = new byte[samplewindowinbytes];
//		ByteBuffer bb = ByteBuffer.wrap(data);
//		bb.order(ByteOrder.nativeOrder());
//		ShortBuffer sb = bb.asShortBuffer();
//		double len = sb.capacity();
//		for (int i = 0; sb.hasRemaining(); i++) {
//			// grow steadily from freq to (freq + freq * 4)
//			double f = (freq + (i / len * freq * 4.0));
//			double d = Math.sin(2.0 * Math.PI * (f / samplerate) * i);
//			sb.put((short) (Short.MAX_VALUE * d));
//		}
//		double[] barkArr = sp.rawToRawBarks(data);
//
//		// catch configuration changes
//		Assert.assertEquals(16, barkStopFreqs.length - 1);
//
//		// System.out.println(Arrays.toString(barkArr));
//
//		// from 100 to 200 hz
//		Assert.assertTrue(barkArr[0] < 1);
//		// from 200 to 300 hz
//		Assert.assertTrue(barkArr[1] < 1);
//		// from 300 to 400 hz
//		Assert.assertTrue(barkArr[2] > 8);
//		// from 400 to 510 hz
//		Assert.assertTrue(barkArr[3] > 25);
//		// from 510 to 630 hz
//		Assert.assertTrue(barkArr[4] > 52);
//		// from 630 to 770 hz
//		Assert.assertTrue(barkArr[5] > 87);
//		// from 770 to 920 hz
//		Assert.assertTrue(barkArr[6] > 123);
//		// from 920 to 1080 hz
//		Assert.assertTrue(barkArr[7] > 147);
//		// from 1080 to 1270 hz
//		Assert.assertTrue(barkArr[8] > 149);
//		// from 1270 to 1480 hz
//		Assert.assertTrue(barkArr[9] > 118);
//		// from 1480 to 1720 hz
//		Assert.assertTrue(barkArr[10] > 61);
//		// from 1720 to 2000 hz
//		Assert.assertTrue(barkArr[11] > 9);
//		// rest
//		Assert.assertTrue(barkArr[12] < 1);
//		Assert.assertTrue(barkArr[13] < 1);
//		Assert.assertTrue(barkArr[14] < 1);
//		Assert.assertTrue(barkArr[15] < 1);
//
//	}
//
//	@Test
//	public void test295Hz() {
//		int freq = 295;
//		int samplewindowinbytes = 8192 * 2;
//		double samplerate = 8192.0;
//		byte[] data = new byte[samplewindowinbytes];
//		ByteBuffer bb = ByteBuffer.wrap(data);
//		bb.order(ByteOrder.nativeOrder());
//		ShortBuffer sb = bb.asShortBuffer();
//		// double len = sb.capacity();
//		for (int i = 0; sb.hasRemaining(); i++) {
//			// grow steadily from freq to (freq + freq * 4)
//			// double f = (freq + (i / len * freq * 4.0));
//			double d = Math.sin(2.0 * Math.PI * (freq / samplerate) * i);
//			sb.put((short) (Short.MAX_VALUE * d));
//		}
//		double[] powerSpect = sp.rawToRawSpectrum(data);
//
//		double[] expecteds = new double[8192 / 2];
//		expecteds[293] = 0.13;
//		expecteds[294] = 1608.6;
//		expecteds[295] = 3216.6;
//		expecteds[296] = 1608.6;
//		expecteds[297] = 0.13;
//		Assert.assertArrayEquals(expecteds, powerSpect, 0.1);
//
//	}
//
//	@Test
//	public void testFrequenciesDesc() {
//		int freq = 220;
//		int samplewindowinbytes = 8192 * 2;
//		double samplerate = 8192.0;
//		byte[] data = new byte[samplewindowinbytes];
//		ByteBuffer bb = ByteBuffer.wrap(data);
//		bb.order(ByteOrder.nativeOrder());
//		ShortBuffer sb = bb.asShortBuffer();
//		double len = sb.capacity();
//		for (int i = 0; sb.hasRemaining(); i++) {
//			// go steadily from (freq + freq * 4) to freq
//			double f = (freq + ((len - i) / len * freq * 4.0));
//			double d = Math.sin(2.0 * Math.PI * (f / samplerate) * i);
//			sb.put((short) (Short.MAX_VALUE * d));
//		}
//		double[] barkArr = sp.rawToRawBarks(data);
//		// System.out.println(Arrays.toString(barkArr));
//		// catch configuration changes
//		Assert.assertEquals(16, barkStopFreqs.length - 1);
//
//		// from 100 to 200 hz
//		Assert.assertTrue(barkArr[0] > 164);
//		// from 200 to 300 hz
//		Assert.assertTrue(barkArr[1] > 158);
//		// from 300 to 400 hz
//		Assert.assertTrue(barkArr[2] > 147);
//		// from 400 to 510 hz
//		Assert.assertTrue(barkArr[3] > 127);
//		// from 510 to 630 hz
//		Assert.assertTrue(barkArr[4] > 100);
//		// from 630 to 770 hz
//		Assert.assertTrue(barkArr[5] > 65);
//		// from 770 to 920 hz
//		// not quite sure why we dont see more data in here
//		Assert.assertTrue(barkArr[6] > 30);
//		// from 920 to 1080 hz
//		// not quite sure why we dont see data in here
//		Assert.assertTrue(barkArr[7] > 5);
//		// from 1080 to 1270 hz
//		Assert.assertTrue(barkArr[8] < 1);
//		// from 1270 to 1480 hz
//		Assert.assertTrue(barkArr[9] < 1);
//		// from 1480 to 1720 hz
//		Assert.assertTrue(barkArr[10] < 1);
//		// from 1720 to 2000 hz
//		Assert.assertTrue(barkArr[11] < 1);
//		// rest
//		Assert.assertTrue(barkArr[12] < 1);
//		Assert.assertTrue(barkArr[13] < 1);
//		Assert.assertTrue(barkArr[14] < 1);
//		Assert.assertTrue(barkArr[15] < 1);
//
//	}
//
//	@Test(expected = BufferUnderflowException.class)
//	public void testTooSmallSample() {
//		Assert.assertTrue(Arrays.equals(new double[16], sp
//				.rawToRawBarks(new byte[8191])));
//	}
//
//	@Test
//	public void testZeroSpectrumTreshold1() {
//		byte[] data = new byte[8192 * 2];
//		ByteBuffer bb = ByteBuffer.wrap(data);
//		bb.order(ByteOrder.nativeOrder());
//		ShortBuffer sb = bb.asShortBuffer();
//		boolean x = true;
//		while (sb.hasRemaining()) {
//			short val = x ? (short) 181 : (short) -181;
//			x = !x;
//			sb.put(val);
//		}
//		Assert.assertArrayEquals(new double[16], sp.rawToRawBarks(data),
//				0.00000000000001);
//	}
//
//	@Test
//	public void testZeroSpectrumTreshold2() {
//		byte[] data = new byte[8192 * 2];
//		ByteBuffer bb = ByteBuffer.wrap(data);
//		bb.order(ByteOrder.nativeOrder());
//		ShortBuffer sb = bb.asShortBuffer();
//		for (int i = 0; sb.hasRemaining(); i++) {
//			short val = i % 4 < 2 ? (short) (Short.MAX_VALUE / 4)
//					: (short) (Short.MIN_VALUE / 4);
//			sb.put(val);
//		}
//
//		double[] barkArr = sp.rawToRawBarks(data);
//		// not equal
//		Assert.assertFalse(Arrays.equals(new double[16], barkArr));
//	}
}
