/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.sample;

import java.util.Arrays;

import org.junit.Assert;
import org.junit.Test;

public class InplaceRemoveDcFunctionTest {

	@Test
	public void test() {
		InplaceRemoveDcFunction f = new InplaceRemoveDcFunction();
		double[] from = new double[10];
		Arrays.fill(from, 10.0);
		f.apply(from);
		double[] expecteds = new double[10];
		Assert.assertArrayEquals(expecteds, from, 0.0001);
	}
	
}
